VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "mscomm32.ocx"
Begin VB.UserControl NETComm 
   ClientHeight    =   585
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   600
   InvisibleAtRuntime=   -1  'True
   PaletteMode     =   4  'None
   Picture         =   "NETComm.ctx":0000
   ScaleHeight     =   585
   ScaleWidth      =   600
   ToolboxBitmap   =   "NETComm.ctx":0102
   Begin MSCommLib.MSComm mComm 
      Left            =   0
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
End
Attribute VB_Name = "NETComm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'Copyright -- Richard L. Grier, 2002
Option Explicit

Event OnComm()

Private mCommEvent As Integer

Private m_Settings As String

Public Enum HandshakeConstants
    comNone = 0
    comXOnXoff = 1
    comRTS = 2
    comXonXoffRTS = 3
End Enum

Public Enum InputModeConstants
    comInputModeText = 0
    comInputModeBinary = 1
End Enum

'--- NETComm event constants
Public Enum NETCommConstants
    NETComm_EV_SEND = 1
    NETComm_EV_RECEIVE = 2
    NETComm_EV_CTS = 3
    NETComm_EV_DSR = 4
    NETComm_EV_CD = 5
    NETComm_EV_RING = 6
    NETComm_EV_EOF = 7

'--- NETComm error code constants
    NETComm_ER_BREAK = 1001
    NETComm_ER_CTSTO = 1002
    NETComm_ER_DSRTO = 1003
    NETComm_ER_FRAME = 1004
    NETComm_ER_OVERRUN = 1006
    NETComm_ER_CDTO = 1007
    NETComm_ER_RXOVER = 1008
    NETComm_ER_RXPARITY = 1009
    NETComm_ER_TXFULL = 1010
End Enum

Private Sub mComm_OnComm()
    mCommEvent = mComm.CommEvent
    RaiseEvent OnComm
End Sub

Public Property Get CommId() As Long
    CommId = mComm.CommId
End Property

Public Property Get CommEvent() As NETCommConstants
Attribute CommEvent.VB_MemberFlags = "400"
    CommEvent = mCommEvent
End Property

Public Property Get CommPort() As Integer
    CommPort = mComm.CommPort
End Property

Public Property Let CommPort(ByVal NewValue As Integer)
    On Error Resume Next
    mComm.CommPort = NewValue
End Property

Public Property Get DTREnable() As Boolean
    DTREnable = mComm.DTREnable
End Property

Public Property Let DTREnable(ByVal NewValue As Boolean)
    mComm.DTREnable = NewValue
End Property

Public Property Get Handshaking() As HandshakeConstants
    Handshaking = mComm.Handshaking
End Property

Public Property Let Handshaking(ByVal NewValue As HandshakeConstants)
    mComm.Handshaking = NewValue
End Property

Public Property Get InBufferSize() As Integer
    InBufferSize = mComm.InBufferSize
End Property

Public Property Let InBufferSize(ByVal NewValue As Integer)
    mComm.InBufferSize = NewValue
End Property

Public Property Get InBufferCount() As Integer
Attribute InBufferCount.VB_MemberFlags = "400"
    InBufferCount = mComm.InBufferCount
End Property

Public Property Let InBufferCount(ByVal NewValue As Integer)
    mComm.InBufferCount = NewValue
End Property

Public Property Get InputLen() As Integer
    InputLen = mComm.InputLen
End Property

Public Property Let InputLen(ByVal NewValue As Integer)
    mComm.InputLen = NewValue
End Property

Public Property Get OutBufferCount() As Integer
Attribute OutBufferCount.VB_MemberFlags = "40"
    OutBufferCount = mComm.OutBufferCount
End Property

Public Property Let OutBufferCount(ByVal NewValue As Integer)
    mComm.OutBufferCount = NewValue
End Property

Public Property Get InputMode() As InputModeConstants
    InputMode = mComm.InputMode
End Property

Public Property Let InputMode(ByVal NewValue As InputModeConstants)
    mComm.InputMode = NewValue
End Property

Public Property Get NullDiscard() As Boolean
    NullDiscard = mComm.NullDiscard
End Property

Public Property Let NullDiscard(ByVal NewValue As Boolean)
    mComm.NullDiscard = NewValue
End Property

Public Property Get OutBufferSize() As Integer
    OutBufferSize = mComm.OutBufferSize
End Property

Public Property Let OutBufferSize(ByVal NewValue As Integer)
    mComm.OutBufferSize = NewValue
End Property

Public Property Get ParityReplace() As String
    ParityReplace = mComm.ParityReplace
End Property

Public Property Let ParityReplace(NewValue As String)
    mComm.ParityReplace = NewValue
End Property

Public Property Get RThreshold() As Integer
    RThreshold = mComm.RThreshold
End Property

Public Property Let RThreshold(ByVal NewValue As Integer)
    mComm.RThreshold = NewValue
End Property

Public Property Let RTSEnable(ByVal NewValue As Boolean)
    mComm.RTSEnable = NewValue
End Property

Public Property Get RTSEnable() As Boolean
    RTSEnable = mComm.RTSEnable
End Property

Public Property Let Settings(NewValue As String)
On Error Resume Next
    m_Settings = NewValue
    mComm.Settings = NewValue
    If Err.Number > 0 Then Err.Raise Err.Number
End Property

Public Property Get Settings() As String
    Settings = m_Settings
End Property

Public Property Let SThreshold(ByVal NewValue As Integer)
    mComm.SThreshold = NewValue
End Property

Public Property Get SThreshold() As Integer
    SThreshold = mComm.SThreshold
End Property

Public Property Get Break() As Boolean
Attribute Break.VB_MemberFlags = "40"
    Break = mComm.Break
End Property

Public Property Let Break(ByVal NewValue As Boolean)
    mComm.Break = NewValue
End Property

Public Property Get CDHolding() As Boolean
Attribute CDHolding.VB_MemberFlags = "40"
    CDHolding = mComm.CDHolding
End Property

Public Property Get CTSHolding() As Boolean
    CTSHolding = mComm.CTSHolding
End Property

Public Property Get DSRHolding() As Boolean
    DSRHolding = mComm.DSRHolding
End Property

Public Property Let Output(vNewValue As Variant)
On Error Resume Next
    If mComm.PortOpen Then mComm.Output = vNewValue
End Property

Public Property Get InputData() As Variant
    InputData = mComm.Input
End Property

Public Property Get PortOpen() As Boolean
Attribute PortOpen.VB_MemberFlags = "400"
    PortOpen = mComm.PortOpen
End Property

Public Property Let PortOpen(ByVal NewValue As Boolean)
    On Error GoTo OpenError
    mComm.PortOpen = NewValue
    Exit Property
OpenError:
     Err.Raise Err.Number, "NETComm", Err.Description
End Property

Private Sub UserControl_Initialize()
    Me.Settings = "9600, N, 8, 1"
End Sub

Private Sub UserControl_InitProperties()
 '   About
'    If Extender.Visible = False Then m_DisplayStatus = False
End Sub

Public Sub About()
Attribute About.VB_Description = "XMComm About"
Attribute About.VB_UserMemId = -552
Attribute About.VB_MemberFlags = "40"
  MsgBox "The NETComm custom control was written using VB6." & vbLf _
  & "It encapsulates the functionallity of the MSComm custom control that" & _
  vbLf & "is furnished with VB6 Professional and Enterprise Editions." & vbLf _
  & vbLf & vbLf & "            Copyright, Richard Grier, 2002"
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Me.Settings = PropBag.ReadProperty("Settings", "38400, N, 8, 1")
    Me.CommPort = PropBag.ReadProperty("CommPort", 1)
    Me.Handshaking = PropBag.ReadProperty("Handshaking", 0)
    Me.InBufferSize = PropBag.ReadProperty("InputBufferSize", 512)
    Me.InputLen = PropBag.ReadProperty("InputLength", 0)
    Me.InputMode = PropBag.ReadProperty("InputMode", 0)
    Me.NullDiscard = PropBag.ReadProperty("NullDiscard", False)
    Me.OutBufferSize = PropBag.ReadProperty("OutputBuffer Size", 512)
    Me.ParityReplace = PropBag.ReadProperty("ParityReplace", "?")
    Me.RThreshold = PropBag.ReadProperty("OnCommReceiveThreshold", 0)
    Me.RTSEnable = PropBag.ReadProperty("RTSEnable", False)
End Sub

Private Sub UserControl_Terminate()
    If mComm.PortOpen Then
        mComm.Handshaking = comNone
        Do Until mComm.InBufferCount = 0
            DoEvents
        Loop
        mComm.PortOpen = False
    End If
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Settings", Me.Settings
    PropBag.WriteProperty "CommPort", Me.CommPort
    PropBag.WriteProperty "Handshaking", Me.Handshaking
    PropBag.WriteProperty "InputBufferSize", Me.InBufferSize
    PropBag.WriteProperty "InputLength", Me.InputLen
    PropBag.WriteProperty "InputMode", Me.InputMode
    PropBag.WriteProperty "NullDiscard", Me.NullDiscard
    PropBag.WriteProperty "OutputBufferSize", Me.OutBufferSize
    PropBag.WriteProperty "ParityReplace", Me.ParityReplace
    PropBag.WriteProperty "OnCommReceiveThreshold", Me.RThreshold
    PropBag.WriteProperty "RTSEnable", Me.RTSEnable
    PropBag.WriteProperty "OnCommSendThreshold", Me.SThreshold
End Sub

